// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { QueryHandler } from "../../../../../../core/decorator/QueryHandlerDecorator";
import { RPCQueryAdapter } from "../../../../../../port/out/rpc/RPCQueryAdapter";
import { lazyInject } from "../../../../../../core/decorator/LazyInjectDecorator";
import SecurityService from "../../../../../service/security/SecurityService";
import { GetExternalControlListsMembersQuery, GetExternalControlListsMembersQueryResponse, } from "./GetExternalControlListsMembersQuery";
import ContractService from "../../../../../service/contract/ContractService";
import AccountService from "../../../../../service/account/AccountService";
let GetExternalControlListsMembersQueryHandler = class GetExternalControlListsMembersQueryHandler {
    securityService;
    accountService;
    contractService;
    queryAdapter;
    constructor(securityService, accountService, contractService, queryAdapter) {
        this.securityService = securityService;
        this.accountService = accountService;
        this.contractService = contractService;
        this.queryAdapter = queryAdapter;
    }
    async execute(query) {
        const { securityId, start, end } = query;
        await this.securityService.get(securityId);
        const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
        const res = await this.queryAdapter.getExternalControlListsMembers(securityEvmAddress, start, end);
        const updatedRes = await Promise.all(res.map(async (address) => (await this.accountService.getAccountInfo(address)).id.toString()));
        return new GetExternalControlListsMembersQueryResponse(updatedRes);
    }
};
GetExternalControlListsMembersQueryHandler = __decorate([
    QueryHandler(GetExternalControlListsMembersQuery),
    __param(0, lazyInject(SecurityService)),
    __param(1, lazyInject(AccountService)),
    __param(2, lazyInject(ContractService)),
    __param(3, lazyInject(RPCQueryAdapter)),
    __metadata("design:paramtypes", [SecurityService,
        AccountService,
        ContractService,
        RPCQueryAdapter])
], GetExternalControlListsMembersQueryHandler);
export { GetExternalControlListsMembersQueryHandler };
